#!/bin/sh
TEMP_DIR="/tmp/firma-digital"

SERIAL=1234
#DESC="Usuarios+Linux+(DEB+64bits)"
DESC="Usuarios+Linux+%28DEB+64bits%29"
FILE="ClientesLinux_DEB64_Rev25.zip"
#TXTD="Distribuciones+basadas+en+DEB+x64.Versiones+Homologadas-Ubuntu+18.04+LTS+o+superior(solo+versiones+LTS)-Debian+10Soporte+únicamente+en+máquinas+Físicas.MD5:3a8c11d0273daee7bfc63a17615a8dc9"
TXTD="Distribuciones+basadas+en+DEB+x64.%0D%0AVersiones+Homologadas%0D%0A-Ubuntu+18.04+LTS+o+superior%28solo+versiones+LTS%29%0D%0A-Debian+10%0D%0A%0D%0ASoporte+%C3%BAnicamente+en+m%C3%A1quinas+F%C3%ADsicas.%0D%0AMD5%3A3a8c11d0273daee7bfc63a17615a8dc9"

urlencode() {
	ENCODEDURL="$(tr -d '\n' | curl -Gs -w %{url_effective} --data-urlencode @- ./ ||: | sed "s/%0[aA]$//;s/^[^?]*?\(.*\)/\1/")"
	printf '%s' "$ENCODEDURL" | sed 's/^http.*?//g'
}

rm -rf "$TEMP_DIR" ; mkdir -p "$TEMP_DIR"
curl -s --compressed 'https://soportefirmadigital.com/sfdj/dl.aspx' \
    -c "$TEMP_DIR/cookies.txt" \
    -o "$TEMP_DIR/descarga.html" || return 1

i=0
ASP_VARS="$(for VAR in __VIEWSTATE __VIEWSTATEGENERATOR __EVENTVALIDATION ; do
    VAL="$(grep -o "id=\"$VAR\"\svalue=\".*\"" "$TEMP_DIR/descarga.html" | cut -d '"' -f 4 | urlencode)"
    [ "$i" != 0 ] && printf '&'
    printf '%s=%s' "$VAR" "$VAL"
    i=+1
done)"

curl 'https://soportefirmadigital.com/sfdj/dl.aspx' \
    --data-raw "__EVENTTARGET=ctl00%24certContents%24LinkButton3&__EVENTARGUMENT=&__LASTFOCUS=&$ASP_VARS&ctl00%24certContents%24hiddenISO=$FILE&ctl00%24certContents%24hidden_ISO_URL=-&ctl00%24certContents%24ddlInstaladores=$DESC&ctl00%24certContents%24txtDescripcion=$TXTD&ctl00%24certContents%24txtSerialNumber=$SERIAL&ctl00%24certContents%24hiddenABID=&ctl00%24certContents%24chkConfirmo=on" \
    -b "$TEMP_DIR/cookies.txt"
